def longest_slide_down(pyramid: list) -> int:
    total = pyramid[0][0]
    last_position = 0
    for i in pyramid[1:]:
        total += max(i[last_position], i[last_position + 1])
        if i[last_position + 1] > i[last_position]:
            last_position += 1
    return total


def test_three():
    assert longest_slide_down([[1], [1, 2], [1, 1, 3]]) == 6


def test_two():
    assert longest_slide_down([[1], [1, 2]]) == 3


def test_one():
    assert longest_slide_down([[1]]) == 1


def test_three_separated():
    assert longest_slide_down([[1], [2, 1], [1, 1, 3]]) == 4


def test_four():
    assert longest_slide_down([[1], [1, 2], [1, 1, 3], [1, 1, 1, 4]]) == 10


def test_four_separated():
    assert longest_slide_down([[1], [1, 2], [1, 1, 3], [4, 1, 1, 1]]) == 7


def test_medium_pyramid():
    assert (
        longest_slide_down(
            [
                [75],
                [95, 64],
                [17, 47, 82],
                [18, 35, 87, 10],
                [20, 4, 82, 47, 65],
                [19, 1, 23, 75, 3, 34],
                [88, 2, 77, 73, 7, 63, 67],
                [99, 65, 4, 28, 6, 16, 70, 92],
                [41, 41, 26, 56, 83, 40, 80, 70, 33],
                [41, 48, 72, 33, 47, 32, 37, 16, 94, 29],
                [53, 71, 44, 65, 25, 43, 91, 52, 97, 51, 14],
                [70, 11, 33, 28, 77, 73, 17, 78, 39, 68, 17, 57],
                [91, 71, 52, 38, 17, 14, 91, 43, 58, 50, 27, 29, 48],
                [63, 66, 4, 68, 89, 53, 67, 30, 73, 16, 69, 87, 40, 31],
                [4, 62, 98, 27, 23, 9, 70, 98, 73, 93, 38, 53, 60, 4, 23],
            ]
        )
        == 1064
    )


def test_medium_pyramid2():
    assert (
        longest_slide_down(
            [
                [75],
                [95, 64],
                [17, 47, 82],
                [18, 35, 87, 10],
                [20, 4, 82, 47, 65],
                [19, 1, 23, 75, 3, 34],
                [88, 2, 77, 73, 7, 63, 67],
                [99, 65, 4, 28, 6, 16, 70, 92],
                [41, 41, 26, 56, 83, 40, 80, 70, 33],
                [41, 48, 72, 33, 47, 32, 37, 16, 94, 29],
                [53, 71, 44, 65, 25, 43, 91, 52, 97, 51, 14],
                [70, 11, 33, 28, 77, 73, 17, 78, 39, 68, 17, 57],
                [91, 71, 52, 38, 17, 14, 91, 43, 58, 50, 27, 29, 48],
                [63, 66, 4, 68, 89, 53, 67, 30, 73, 16, 69, 87, 40, 31],
                [4, 62, 98, 27, 23, 9, 70, 98, 73, 93, 38, 53, 60, 4, 23],
                [4, 62, 98, 27, 23, 9, 70, 100, 73, 93, 38, 53, 60, 4, 23, 99],
            ]
        )
        == 1164
    )
